#!/bin/sh

#
# tests file "$1" and counts all parsed words. This count should
# be equal to "$2". If this is the case, "success!" will be written
# else "failure!". Should there be a wrong usage of parsefile(), print
# error message and exit with 1.
#
parsefile()
{
	if [ -z "$1" ] || [ -z "$2" ]
	then
		echo "wrong usage of parsefile()!"
		exit 1
	fi
		
	echo -n "wordcount of $1 should be $2: "
	./testloadwords -w $1
	if [ $? != $2 ]
	then
		echo "failure!"
	else
		echo "success!"
	fi
}

#
# tests file "$1" and parses return value. This return value should
# be equal to "$2". If this is the case, "success!" will be written
# else "failure!". Should there be a wrong usage of testfile(), print
# error message and exit with 1.
#
testfile()
{
	if [ -z "$1" ] || [ -z "$2" ]
	then
		echo "wrong usage of testfile()!"
		exit 1
	fi
		
	echo -n "result for $1 should be $2: "
	./testloadwords $1
	if [ $? != $2 ]
	then
		echo "failure!"
	else
		echo "success!"
	fi
}

cat > words.template << "EOF"
testwords
a
b
c
d
e
f
g
h
i
j
K
l
M
n
o
p
q
r
s
t
u
v
w
x
y
z
EOF

parsefile words.template 26
sed s/'y'/''/ words.template > words.blankline
parsefile words.blankline 25
sed s/'y'/'yyyyyyyyyyyyyyyyyyyyyyyyyyyyyy'/ words.template > words.longline
parsefile words.longline 25
sed s/'y'/'a'/ words.template > words.duplicate
parsefile words.duplicate 25
sed s/'y'/'y	y'/ words.template > words.tab
parsefile words.tab 25
sed s/'y'/'y y'/ words.template > words.blank
parsefile words.blank 25
sed s/'testwords'/'too long too long too long too long too long too long too long too long too long too long'/ words.template > words.longdescription
parsefile words.longdescription 26

touch words.empty
testfile words.empty 102
echo "description only" > words.only_description
testfile words.only_description 102
testfile words.nonexistent 102
testfile /dev/null 102
testfile ./ 102

rm words.*
